#
# Makefile for utils for Atari TOS gcc
# - adjust CROSSDIR below for your setup if cross compiling otherwise
#   adjust CC
#
#
CROSSDIR = /dsrg/bammi/cross-gcc
CROSSBIN = $(CROSSDIR)/bin
CROSSLIB = $(CROSSDIR)/lib
CROSSINC = $(CROSSDIR)/include

# Cross GCC
CC=$(CROSSBIN)/cgcc

CFLAGS = -O -Datarist -I.

ALL = gcc-ld.ttp sym-ld.ttp gcc-nm.ttp gcc-ar.ttp gcc-size.ttp size68.ttp \
      cnm.ttp fixstk.ttp printstk.ttp
all: $(ALL)

#
# the 'regular' linker, produces atari executables
#
gcc-ld.ttp : ld.o
	$(CC) -o gcc-ld.ttp ld.o

#
# the 'other' linker, produdes atari gdb compat symb files
#
sym-ld.ttp : sym-ld.o
	$(CC) -o sym-ld.ttp sym-ld.o

#
# symbol lister (NaMe list) gnu format only -- ie .o's and .olb's only
#
gcc-nm.ttp: nm.o
	$(CC) -o gcc-nm.ttp nm.o

# 
# Object file sizes (gnu format only) -- .o's and .olb's only
#
gcc-size.ttp: size.o
	$(CC) -o gcc-size.ttp size.o

#
# gcc-ar.ttp - archiver/librarian
#
gcc-ar.ttp : ar.o
	$(CC) -o gcc-ar.ttp ar.o

#
# show sizes of tos format executable
#
size68.ttp: size68.c
	$(CC) -O -o size68.ttp size68.c -s

#
# show symbols of tos format executable
# absolute minimal functionality.
#
cnm.ttp: cnm.c
	$(CC) -O -o cnm.ttp cnm.c

#
# print _stksize
#
printstk.ttp : printstk.c
	$(CC) -O -o printstk.ttp printstk.c -mshort

#
# fix _stksize
#
fixstk.ttp : fixstk.c
	$(CC) -O -o fixstk.ttp fixstk.c -mshort

clean:
	rm -f *.o core

realclean: clean
	rm -f $(ALL)
